// CDUCCPLC.cpp :  Microsoft Visual C++  ActiveX ؼװĶ


#include "stdafx.h"
#include "CDUCCPLC.h"

// Dispatch interfaces referenced by this interface
#include "xdpage.h"
#include "xdwindow.h"
#include "xdshape.h"
#include "xdgroupshape.h"
#include "xdlinkshape.h"
#include "xdportsshape.h"
#include "xdportshape.h"
#include "xdeformshape.h"

/////////////////////////////////////////////////////////////////////////////
// CDUCCPLC

IMPLEMENT_DYNCREATE(CDUCCPLC, CWnd)

/////////////////////////////////////////////////////////////////////////////
// CDUCCPLC properties

long CDUCCPLC::GetCanvasWidth()
{
	long result;
	GetProperty(0x1, VT_I4, (void*)&result);
	return result;
}

void CDUCCPLC::SetCanvasWidth(long propVal)
{
	SetProperty(0x1, VT_I4, propVal);
}

long CDUCCPLC::GetCanvasHeight()
{
	long result;
	GetProperty(0x2, VT_I4, (void*)&result);
	return result;
}

void CDUCCPLC::SetCanvasHeight(long propVal)
{
	SetProperty(0x2, VT_I4, propVal);
}

LPDISPATCH CDUCCPLC::GetParent()
{
	LPDISPATCH result;
	GetProperty(0x7be, VT_DISPATCH, (void*)&result);
	return result;
}

void CDUCCPLC::SetParent(LPDISPATCH propVal)
{
	SetProperty(0x7be, VT_DISPATCH, propVal);
}

LPDISPATCH CDUCCPLC::GetRoot()
{
	LPDISPATCH result;
	GetProperty(0x7bd, VT_DISPATCH, (void*)&result);
	return result;
}

void CDUCCPLC::SetRoot(LPDISPATCH propVal)
{
	SetProperty(0x7bd, VT_DISPATCH, propVal);
}

CXDPage CDUCCPLC::GetActivePage()
{
	LPDISPATCH pDispatch;
	GetProperty(0x7bb, VT_DISPATCH, (void*)&pDispatch);
	return CXDPage(pDispatch);
}

void CDUCCPLC::SetActivePage(LPDISPATCH propVal)
{
	SetProperty(0x7bb, VT_DISPATCH, propVal);
}

CXDWindow CDUCCPLC::GetActiveWindow()
{
	LPDISPATCH pDispatch;
	GetProperty(0x7bc, VT_DISPATCH, (void*)&pDispatch);
	return CXDWindow(pDispatch);
}

void CDUCCPLC::SetActiveWindow(LPDISPATCH propVal)
{
	SetProperty(0x7bc, VT_DISPATCH, propVal);
}

long CDUCCPLC::AddRectShape(short xLeft, short xTop, short xRight, short xBottom, LPCTSTR lpszCaption)
{
	long result;
	static BYTE parms[] =
		VTS_I2 VTS_I2 VTS_I2 VTS_I2 VTS_BSTR;
	InvokeHelper(0x3, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		xLeft, xTop, xRight, xBottom, lpszCaption);
	return result;
}

long CDUCCPLC::AddTextShape(short xLeft, short xTop, short xRight, short xBottom, LPCTSTR lpszText)
{
	long result;
	static BYTE parms[] =
		VTS_I2 VTS_I2 VTS_I2 VTS_I2 VTS_BSTR;
	InvokeHelper(0x4, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		xLeft, xTop, xRight, xBottom, lpszText);
	return result;
}

long CDUCCPLC::AddEllipseShape(short xLeft, short xTop, short xRight, short xBottom, LPCTSTR lpszCaption)
{
	long result;
	static BYTE parms[] =
		VTS_I2 VTS_I2 VTS_I2 VTS_I2 VTS_BSTR;
	InvokeHelper(0x5, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		xLeft, xTop, xRight, xBottom, lpszCaption);
	return result;
}

long CDUCCPLC::AddRoundRectShape(short xLeft, short xTop, short xRight, short xBottom, LPCTSTR lpszCaption)
{
	long result;
	static BYTE parms[] =
		VTS_I2 VTS_I2 VTS_I2 VTS_I2 VTS_BSTR;
	InvokeHelper(0x6, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		xLeft, xTop, xRight, xBottom, lpszCaption);
	return result;
}

long CDUCCPLC::AddHyLinkShape(short xLeft, short yTop, short xRight, short yBottom, LPCTSTR lpszCaption)
{
	long result;
	static BYTE parms[] =
		VTS_I2 VTS_I2 VTS_I2 VTS_I2 VTS_BSTR;
	InvokeHelper(0x7, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		xLeft, yTop, xRight, yBottom, lpszCaption);
	return result;
}

long CDUCCPLC::AddBmpFileShape(short xLeft, short yTop, short xRight, short yBottom, LPCTSTR lpszFileName, LPCTSTR lpszCaption)
{
	long result;
	static BYTE parms[] =
		VTS_I2 VTS_I2 VTS_I2 VTS_I2 VTS_BSTR VTS_BSTR;
	InvokeHelper(0x8, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		xLeft, yTop, xRight, yBottom, lpszFileName, lpszCaption);
	return result;
}

long CDUCCPLC::AddEmfFileShape(short xLeft, short yTop, short xRight, short yBottom, LPCTSTR lpszFileName, LPCTSTR lpszCaption)
{
	long result;
	static BYTE parms[] =
		VTS_I2 VTS_I2 VTS_I2 VTS_I2 VTS_BSTR VTS_BSTR;
	InvokeHelper(0x9, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		xLeft, yTop, xRight, yBottom, lpszFileName, lpszCaption);
	return result;
}

long CDUCCPLC::AddWmfFileShape(short xLeft, short yTop, short xRight, short yBottom, LPCTSTR lpszFileName, LPCTSTR lpszCaption)
{
	long result;
	static BYTE parms[] =
		VTS_I2 VTS_I2 VTS_I2 VTS_I2 VTS_BSTR VTS_BSTR;
	InvokeHelper(0xa, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		xLeft, yTop, xRight, yBottom, lpszFileName, lpszCaption);
	return result;
}

long CDUCCPLC::AddShapeByType(short nType, short xLeft, short yTop, short xRight, short yBottom, LPCTSTR lpszFileName)
{
	long result;
	static BYTE parms[] =
		VTS_I2 VTS_I2 VTS_I2 VTS_I2 VTS_I2 VTS_BSTR;
	InvokeHelper(0xb, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		nType, xLeft, yTop, xRight, yBottom, lpszFileName);
	return result;
}

long CDUCCPLC::AddCompositeShapeByFile(short xLeft, short xTop, short xRight, short xBottom, LPCTSTR lpszFileName, LPCTSTR lpszCaption)
{
	long result;
	static BYTE parms[] =
		VTS_I2 VTS_I2 VTS_I2 VTS_I2 VTS_BSTR VTS_BSTR;
	InvokeHelper(0xc, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		xLeft, xTop, xRight, xBottom, lpszFileName, lpszCaption);
	return result;
}

long CDUCCPLC::AddCompositeShapeByID(short xLeft, short yTop, short xRight, short yBottom, short nResId, LPCTSTR lpszCaption)
{
	long result;
	static BYTE parms[] =
		VTS_I2 VTS_I2 VTS_I2 VTS_I2 VTS_I2 VTS_BSTR;
	InvokeHelper(0xd, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		xLeft, yTop, xRight, yBottom, nResId, lpszCaption);
	return result;
}

long CDUCCPLC::AddLineShape(long xStart, long yStart, long xEnd, long yEnd, BOOL bArrow)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_BOOL;
	InvokeHelper(0xe, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		xStart, yStart, xEnd, yEnd, bArrow);
	return result;
}

long CDUCCPLC::AddDimLineShape(long xStart, long yStart, long xEnd, long yEnd, long nWidth, BOOL bArrow)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_BOOL;
	InvokeHelper(0xf, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		xStart, yStart, xEnd, yEnd, nWidth, bArrow);
	return result;
}

BOOL CDUCCPLC::Read(LPCTSTR lpszFileName)
{
	BOOL result;
	static BYTE parms[] =
		VTS_BSTR;
	InvokeHelper(0x10, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms,
		lpszFileName);
	return result;
}

BOOL CDUCCPLC::Write(LPCTSTR lpszFileName)
{
	BOOL result;
	static BYTE parms[] =
		VTS_BSTR;
	InvokeHelper(0x11, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms,
		lpszFileName);
	return result;
}

void CDUCCPLC::Export()
{
	InvokeHelper(0x12, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::Undo()
{
	InvokeHelper(0x13, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::Redo()
{
	InvokeHelper(0x14, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::Cut()
{
	InvokeHelper(0x15, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::Copy()
{
	InvokeHelper(0x16, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::Paste()
{
	InvokeHelper(0x17, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::Clear()
{
	InvokeHelper(0x18, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::ClearAll()
{
	InvokeHelper(0x19, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::SelectAll()
{
	InvokeHelper(0x1a, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

BOOL CDUCCPLC::GetShowGrid()
{
	BOOL result;
	InvokeHelper(0x1b, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCPLC::SetShowGrid(BOOL bGrid)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0x1c, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bGrid);
}

void CDUCCPLC::OnGridProp()
{
	InvokeHelper(0x1d, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

BOOL CDUCCPLC::GetDesignMode()
{
	BOOL result;
	InvokeHelper(0x1e, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCPLC::SetDesignMode(BOOL bMode)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0x1f, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bMode);
}

BOOL CDUCCPLC::GetSnapToGrid()
{
	BOOL result;
	InvokeHelper(0x20, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCPLC::SetSnapToGrid(BOOL bSnap)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0x21, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bSnap);
}

BOOL CDUCCPLC::GetGlueToHandle()
{
	BOOL result;
	InvokeHelper(0x22, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCPLC::SetGlueToHandle(BOOL bGlue)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0x23, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bGlue);
}

BOOL CDUCCPLC::GetShowPageBreakLine()
{
	BOOL result;
	InvokeHelper(0x24, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCPLC::SetShowPageBreakLine(BOOL bShow)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0x25, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bShow);
}

BOOL CDUCCPLC::GetShowPort()
{
	BOOL result;
	InvokeHelper(0x26, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCPLC::SetShowPort(BOOL bShow)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0x27, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bShow);
}

long CDUCCPLC::GetZoomPercent()
{
	long result;
	InvokeHelper(0x28, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
	return result;
}

void CDUCCPLC::SetZoomPercent(long nZoom)
{
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x29, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		nZoom);
}

void CDUCCPLC::ZoomIn()
{
	InvokeHelper(0x2a, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::ZoomOut()
{
	InvokeHelper(0x2b, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::ZoomToFitPage()
{
	InvokeHelper(0x2c, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::ZoomToFitPageHeight()
{
	InvokeHelper(0x2d, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::ZoomToFitPageWidth()
{
	InvokeHelper(0x2e, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::ZoomToFitSelect()
{
	InvokeHelper(0x2f, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::ZoomToRect(long xLeft, long yTop, long xRight, long yBottom)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4 VTS_I4;
	InvokeHelper(0x30, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		xLeft, yTop, xRight, yBottom);
}

void CDUCCPLC::ZoomToSelection()
{
	InvokeHelper(0x31, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::DoZoomWithinRect()
{
	InvokeHelper(0x32, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::DoShowPagePropDlg()
{
	InvokeHelper(0x33, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::DoShowHeaderAndFooterDlg()
{
	InvokeHelper(0x34, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::DoShowTextDlg()
{
	InvokeHelper(0x35, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::DoShowBulletsDlg()
{
	InvokeHelper(0x36, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::DoShowLineDlg()
{
	InvokeHelper(0x37, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::DoShowFillDlg()
{
	InvokeHelper(0x38, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::DoShowShadowDlg()
{
	InvokeHelper(0x39, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::DoShowEventDlg()
{
	InvokeHelper(0x3a, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::DoShowCustomDlg()
{
	InvokeHelper(0x3b, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::DoDrawSelect()
{
	InvokeHelper(0x3c, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::DoDrawLine()
{
	InvokeHelper(0x3d, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::DoDrawArrowLine()
{
	InvokeHelper(0x3e, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::DoDrawCrossLine()
{
	InvokeHelper(0x3f, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::DoDrawArrowBezierLine()
{
	InvokeHelper(0x40, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::DoDrawDimLine()
{
	InvokeHelper(0x41, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::DoDrawFreeLine()
{
	InvokeHelper(0x42, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::DoDrawFreeCloseLine()
{
	InvokeHelper(0x43, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::DoDrawPolyLine()
{
	InvokeHelper(0x44, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::DoDrawPolygon()
{
	InvokeHelper(0x45, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::DoDrawEllipse()
{
	InvokeHelper(0x46, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::DoDrawRectangle()
{
	InvokeHelper(0x47, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::DoDrawRoundRect()
{
	InvokeHelper(0x48, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::DoDrawCloseBezier()
{
	InvokeHelper(0x49, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::DoDrawBezierLine()
{
	InvokeHelper(0x4a, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::DoDrawStatic()
{
	InvokeHelper(0x4b, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::DoDrawButton()
{
	InvokeHelper(0x4c, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::DoDoDrawImage()
{
	InvokeHelper(0x4d, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::DoDrawPort()
{
	InvokeHelper(0x4e, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::DrawCustomRect(long nType)
{
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x4f, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		nType);
}

void CDUCCPLC::DoDrawLinkNormal()
{
	InvokeHelper(0x50, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::DoDrawLinkUpRight()
{
	InvokeHelper(0x51, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::DoDrawCornerLink()
{
	InvokeHelper(0x52, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::DoDrawBezierLink()
{
	InvokeHelper(0x53, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::DoRotate()
{
	InvokeHelper(0x54, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::DoRotateLeft()
{
	InvokeHelper(0x55, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::DoRotateRight()
{
	InvokeHelper(0x56, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::DoFlipHorz()
{
	InvokeHelper(0x57, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::DoFlipVert()
{
	InvokeHelper(0x58, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::RotateAngle(long nAngle)
{
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x59, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		nAngle);
}

long CDUCCPLC::GetRotateShapeCount()
{
	long result;
	InvokeHelper(0x5a, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
	return result;
}

void CDUCCPLC::Group()
{
	InvokeHelper(0x5b, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::UnGroup()
{
	InvokeHelper(0x5c, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

BOOL CDUCCPLC::EnableUnGroup()
{
	BOOL result;
	InvokeHelper(0x5d, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCPLC::DoAlignLeft()
{
	InvokeHelper(0x5e, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::DoAlignRight()
{
	InvokeHelper(0x5f, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::DoAlignTop()
{
	InvokeHelper(0x60, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::DoAlignBottom()
{
	InvokeHelper(0x61, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::DoAlignCenter()
{
	InvokeHelper(0x62, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::DoAlignVcenter()
{
	InvokeHelper(0x63, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::DoAlignInviewHor()
{
	InvokeHelper(0x64, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::DoAlignInviewVer()
{
	InvokeHelper(0x65, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::DoSpaceAcross()
{
	InvokeHelper(0x66, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::DoSpaceDown()
{
	InvokeHelper(0x67, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::DoSizeWidth()
{
	InvokeHelper(0x68, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::DoSizeHeight()
{
	InvokeHelper(0x69, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::DoSizeAll()
{
	InvokeHelper(0x6a, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::DoLockcomp()
{
	InvokeHelper(0x6b, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::DoUnlockcomp()
{
	InvokeHelper(0x6c, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::DoMoveForward()
{
	InvokeHelper(0x6d, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::DoMoveBack()
{
	InvokeHelper(0x6e, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::DoMoveBackward()
{
	InvokeHelper(0x6f, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::DoCmdNudgeleft()
{
	InvokeHelper(0x70, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::DoCmdNudgeright()
{
	InvokeHelper(0x71, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::DoCmdNudgetop()
{
	InvokeHelper(0x72, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::DoCmdNudgebottom()
{
	InvokeHelper(0x73, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::DoCmdAutoPan()
{
	InvokeHelper(0x74, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

long CDUCCPLC::GetTotalSelect()
{
	long result;
	InvokeHelper(0x75, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
	return result;
}

void CDUCCPLC::DoEditSpot()
{
	InvokeHelper(0x76, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::ClearSelectionHandles()
{
	InvokeHelper(0x77, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::RestoreSelectionHandles()
{
	InvokeHelper(0x78, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::UpdateSelection()
{
	InvokeHelper(0x79, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::UpdateScrollSize()
{
	InvokeHelper(0x7a, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::DoTabOrder()
{
	InvokeHelper(0x7b, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::SetModifiedFlag(BOOL bFlag)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0x7c, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bFlag);
}

BOOL CDUCCPLC::GetModifiedFlag()
{
	BOOL result;
	InvokeHelper(0x7d, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

long CDUCCPLC::HitTest(long xPoint, long yPoint)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x7e, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		xPoint, yPoint);
	return result;
}

long CDUCCPLC::HitTestPort(long xPoint, long yPoint)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x7f, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		xPoint, yPoint);
	return result;
}

long CDUCCPLC::GetCompsCount()
{
	long result;
	InvokeHelper(0x80, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
	return result;
}

void CDUCCPLC::SetPagePosition(long xLeft, long yTop, long xRight, long yBottom)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4 VTS_I4;
	InvokeHelper(0x81, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		xLeft, yTop, xRight, yBottom);
}

void CDUCCPLC::ChangePositionWithPages(long nHorzPages, long nVertPages)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x82, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		nHorzPages, nVertPages);
}

void CDUCCPLC::SetLockWithPages(BOOL bLock)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0x83, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bLock);
}

unsigned long CDUCCPLC::GetGridColor()
{
	unsigned long result;
	InvokeHelper(0x84, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
	return result;
}

void CDUCCPLC::SetGridColor(long crColor)
{
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x85, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		crColor);
}

long CDUCCPLC::GetGridX()
{
	long result;
	InvokeHelper(0x86, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
	return result;
}

void CDUCCPLC::SetGridX(long nValue)
{
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x87, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		nValue);
}

long CDUCCPLC::GetGridY()
{
	long result;
	InvokeHelper(0x88, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
	return result;
}

void CDUCCPLC::SetGridY(long nValue)
{
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x89, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		nValue);
}

long CDUCCPLC::GetBkColor()
{
	long result;
	InvokeHelper(0x8a, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
	return result;
}

void CDUCCPLC::SetBkColor(long crColor)
{
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x8b, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		crColor);
}

long CDUCCPLC::GetPageBkColor()
{
	long result;
	InvokeHelper(0x8c, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
	return result;
}

void CDUCCPLC::SetPageBkColor(long crColor)
{
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x8d, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		crColor);
}

long CDUCCPLC::GetBrushType()
{
	long result;
	InvokeHelper(0x8e, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
	return result;
}

void CDUCCPLC::SetBrushType(short nType)
{
	static BYTE parms[] =
		VTS_I2;
	InvokeHelper(0x8f, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		nType);
}

long CDUCCPLC::GetPatternColor()
{
	long result;
	InvokeHelper(0x90, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
	return result;
}

void CDUCCPLC::SetPatternColor(long crColor)
{
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x91, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		crColor);
}

BOOL CDUCCPLC::IsFormMode()
{
	BOOL result;
	InvokeHelper(0x92, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCPLC::SetFormMode(BOOL bForm)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0x93, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bForm);
}

long CDUCCPLC::GetCommandState()
{
	long result;
	InvokeHelper(0x94, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
	return result;
}

BOOL CDUCCPLC::CanUndo()
{
	BOOL result;
	InvokeHelper(0x95, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

BOOL CDUCCPLC::CanRedo()
{
	BOOL result;
	InvokeHelper(0x96, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

BOOL CDUCCPLC::CanPaste()
{
	BOOL result;
	InvokeHelper(0x97, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

long CDUCCPLC::GetGridStyle()
{
	long result;
	InvokeHelper(0x98, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
	return result;
}

void CDUCCPLC::SetGridLineType(short nType)
{
	static BYTE parms[] =
		VTS_I2;
	InvokeHelper(0x99, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		nType);
}

void CDUCCPLC::DoPrintPreview(LPDISPATCH frm)
{
	static BYTE parms[] =
		VTS_DISPATCH;
	InvokeHelper(0x9a, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		frm);
}

void CDUCCPLC::PrintDraw()
{
	InvokeHelper(0x9b, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::ChangeModelBoolProp(BOOL bValue, long nPropID)
{
	static BYTE parms[] =
		VTS_BOOL VTS_I4;
	InvokeHelper(0x9c, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bValue, nPropID);
}

void CDUCCPLC::ChangeModelStringProp(LPCTSTR strValue, long nPropID)
{
	static BYTE parms[] =
		VTS_BSTR VTS_I4;
	InvokeHelper(0x9d, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		strValue, nPropID);
}

void CDUCCPLC::ChangeModelIntProp(long nValue, long nPropID)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x9e, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		nValue, nPropID);
}

void CDUCCPLC::ChangeModelUINTProp(long nValue, long nPropID)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x9f, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		nValue, nPropID);
}

void CDUCCPLC::ChangeModelFloatProp(float fValue, long nPropID)
{
	static BYTE parms[] =
		VTS_R4 VTS_I4;
	InvokeHelper(0xa0, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		fValue, nPropID);
}

void CDUCCPLC::ChangeModelDoubleProp(double dValue, long nPropID)
{
	static BYTE parms[] =
		VTS_R8 VTS_I4;
	InvokeHelper(0xa1, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		dValue, nPropID);
}

void CDUCCPLC::ChangeModelDateTimeProp(DATE dtValue, long nPropID)
{
	static BYTE parms[] =
		VTS_DATE VTS_I4;
	InvokeHelper(0xa2, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		dtValue, nPropID);
}

void CDUCCPLC::ChangeModelColorProp(long crValue, long nPropID)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0xa3, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		crValue, nPropID);
}

void CDUCCPLC::ChangeModelDWordProp(long dwValue, short nPropID)
{
	static BYTE parms[] =
		VTS_I4 VTS_I2;
	InvokeHelper(0xa4, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		dwValue, nPropID);
}

void CDUCCPLC::ChangeSingleShapeBoolProp(long shape, BOOL bValue, long nPropID)
{
	static BYTE parms[] =
		VTS_I4 VTS_BOOL VTS_I4;
	InvokeHelper(0xa5, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, bValue, nPropID);
}

void CDUCCPLC::ChangeSingleShapeStringProp(long shape, LPCTSTR strValue, long nPropID)
{
	static BYTE parms[] =
		VTS_I4 VTS_BSTR VTS_I4;
	InvokeHelper(0xa6, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, strValue, nPropID);
}

void CDUCCPLC::ChangeSingleShapeIntProp(long shape, long nValue, long nPropID)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4;
	InvokeHelper(0xa7, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, nValue, nPropID);
}

void CDUCCPLC::ChangeSingleShapeUINTProp(long shape, long nValue, long nPropID)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4;
	InvokeHelper(0xa8, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, nValue, nPropID);
}

void CDUCCPLC::ChangeSingleShapeFloatProp(long shape, float fValue, long nPropID)
{
	static BYTE parms[] =
		VTS_I4 VTS_R4 VTS_I4;
	InvokeHelper(0xa9, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, fValue, nPropID);
}

void CDUCCPLC::ChangeSingleShapeDoubleProp(long shape, double dValue, long nPropID)
{
	static BYTE parms[] =
		VTS_I4 VTS_R8 VTS_I4;
	InvokeHelper(0xaa, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, dValue, nPropID);
}

void CDUCCPLC::ChangeSingleShapeDateTimeProp(long shape, DATE dtValue, long nPropID)
{
	static BYTE parms[] =
		VTS_I4 VTS_DATE VTS_I4;
	InvokeHelper(0xab, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, dtValue, nPropID);
}

void CDUCCPLC::ChangeSingleShapeColorProp(long shape, long crValue, long nPropID)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4;
	InvokeHelper(0xac, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, crValue, nPropID);
}

void CDUCCPLC::ChangeSingleShapeDWordProp(long shape, long dwValue, long nPropID)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4;
	InvokeHelper(0xad, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, dwValue, nPropID);
}

void CDUCCPLC::ChangeSelectionBoolProp(BOOL bValue, long nPropID)
{
	static BYTE parms[] =
		VTS_BOOL VTS_I4;
	InvokeHelper(0xae, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bValue, nPropID);
}

void CDUCCPLC::ChangeSelectionStringProp(LPCTSTR strValue, long nPropID)
{
	static BYTE parms[] =
		VTS_BSTR VTS_I4;
	InvokeHelper(0xaf, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		strValue, nPropID);
}

void CDUCCPLC::ChangeSelectionIntProp(long nValue, long nPropID)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0xb0, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		nValue, nPropID);
}

void CDUCCPLC::ChangeSelectionUINTProp(long nValue, long nPropID)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0xb1, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		nValue, nPropID);
}

void CDUCCPLC::ChangeSelectionFloatProp(float fValue, long nPropID)
{
	static BYTE parms[] =
		VTS_R4 VTS_I4;
	InvokeHelper(0xb2, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		fValue, nPropID);
}

void CDUCCPLC::ChangeSelectionDoubleProp(double dValue, long nPropID)
{
	static BYTE parms[] =
		VTS_R8 VTS_I4;
	InvokeHelper(0xb3, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		dValue, nPropID);
}

void CDUCCPLC::ChangeSelectionDateTimeProp(DATE dtValue, long nPropID)
{
	static BYTE parms[] =
		VTS_DATE VTS_I4;
	InvokeHelper(0xb4, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		dtValue, nPropID);
}

void CDUCCPLC::ChangeSelectionColorProp(long crValue, long nPropID)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0xb5, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		crValue, nPropID);
}

void CDUCCPLC::ChangeSelectionDWordProp(long dwValue, long nPropID)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0xb6, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		dwValue, nPropID);
}

void CDUCCPLC::AddUserData(long shape, long dwData)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0xb7, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, dwData);
}

long CDUCCPLC::GetUserData(long shape)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0xb8, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		shape);
	return result;
}

void CDUCCPLC::MoveShape(long shape, long nxOffset, long nyOffset)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4;
	InvokeHelper(0xb9, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, nxOffset, nyOffset);
}

void CDUCCPLC::ResizeShape(long shape, double dScaleX, double dScaleY, double dOX, double dOY)
{
	static BYTE parms[] =
		VTS_I4 VTS_R8 VTS_R8 VTS_R8 VTS_R8;
	InvokeHelper(0xba, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, dScaleX, dScaleY, dOX, dOY);
}

void CDUCCPLC::RotateShape(long shape, long nAngle, double dOX, double dOY)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_R8 VTS_R8;
	InvokeHelper(0xbb, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, nAngle, dOX, dOY);
}

void CDUCCPLC::PositionShape(long shape, long xLeft, long yTop, long xRight, long yBottom)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4;
	InvokeHelper(0xbc, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, xLeft, yTop, xRight, yBottom);
}

long CDUCCPLC::GetCurrentSelectShape()
{
	long result;
	InvokeHelper(0xbd, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
	return result;
}

long CDUCCPLC::FindShapeByCaption(LPCTSTR lpszCaption)
{
	long result;
	static BYTE parms[] =
		VTS_BSTR;
	InvokeHelper(0xbe, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		lpszCaption);
	return result;
}

long CDUCCPLC::FindShapeByName(LPCTSTR lpszName)
{
	long result;
	static BYTE parms[] =
		VTS_BSTR;
	InvokeHelper(0xbf, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		lpszName);
	return result;
}

void CDUCCPLC::DoPageSetup()
{
	InvokeHelper(0xc0, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

BOOL CDUCCPLC::IsEditSpots()
{
	BOOL result;
	InvokeHelper(0xc1, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCPLC::DoShowCompsSelectDlg()
{
	InvokeHelper(0xc2, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

long CDUCCPLC::GetTotalGroupShapes()
{
	long result;
	InvokeHelper(0xc3, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
	return result;
}

void CDUCCPLC::DoMoveFront()
{
	InvokeHelper(0xc4, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

BOOL CDUCCPLC::IsTabOrder()
{
	BOOL result;
	InvokeHelper(0xc5, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

long CDUCCPLC::GetDrawType()
{
	long result;
	InvokeHelper(0xc6, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
	return result;
}

void CDUCCPLC::DoDrawCustomShapeID(long nResId)
{
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0xc7, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		nResId);
}

void CDUCCPLC::DoDrawCustomShapeFile(LPCTSTR lpszResFile)
{
	static BYTE parms[] =
		VTS_BSTR;
	InvokeHelper(0xc8, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		lpszResFile);
}

void CDUCCPLC::UpdateAllShapes()
{
	InvokeHelper(0xc9, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::UpdateCanvas()
{
	InvokeHelper(0xca, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::DoDrawTable()
{
	InvokeHelper(0xcb, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::DoDrawArcLine()
{
	InvokeHelper(0xcc, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::DoDrawPie()
{
	InvokeHelper(0xcd, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::DoShowPanWnd()
{
	InvokeHelper(0xce, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

BOOL CDUCCPLC::IsPanWndShow()
{
	BOOL result;
	InvokeHelper(0xcf, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCPLC::EnableDisappearHandle(BOOL bEnable)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0xd0, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bEnable);
}

BOOL CDUCCPLC::IsEnablePickNearest()
{
	BOOL result;
	InvokeHelper(0xd1, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCPLC::EnablePickNearest(BOOL bEnable)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0xd2, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bEnable);
}

BOOL CDUCCPLC::IsAngleSnapEnabled()
{
	BOOL result;
	InvokeHelper(0xd3, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCPLC::EnableAngleSnap(BOOL bEnable)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0xd4, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bEnable);
}

void CDUCCPLC::SetSnapAngle(long nWink)
{
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0xd5, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		nWink);
}

long CDUCCPLC::GetSnapAngle()
{
	long result;
	InvokeHelper(0xd6, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
	return result;
}

void CDUCCPLC::SetPrimarySelectionColor(long crColor)
{
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0xd7, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		crColor);
}

void CDUCCPLC::SetSecondarySelectionColor(long crColor)
{
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0xd8, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		crColor);
}

void CDUCCPLC::AddShapePort(double dScaleX, double dScaleY)
{
	static BYTE parms[] =
		VTS_R8 VTS_R8;
	InvokeHelper(0xd9, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		dScaleX, dScaleY);
}

void CDUCCPLC::DoDrawMultiSelect()
{
	InvokeHelper(0xda, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

long CDUCCPLC::AddArcLineShape(long xStart, long yStart, long xEnd, long yEnd, long nWidth, BOOL bArrow)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_BOOL;
	InvokeHelper(0xdb, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		xStart, yStart, xEnd, yEnd, nWidth, bArrow);
	return result;
}

long CDUCCPLC::AddTabShape(long nLeft, long nTop, long nRight, long nBottom, long nRows, long nCols, BOOL bFixRows, BOOL bFixCols, BOOL bShowGridLine)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_BOOL VTS_BOOL VTS_BOOL;
	InvokeHelper(0xdc, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		nLeft, nTop, nRight, nBottom, nRows, nCols, bFixRows, bFixCols, bShowGridLine);
	return result;
}

BOOL CDUCCPLC::IsMultiSelectMode()
{
	BOOL result;
	InvokeHelper(0xdd, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

long CDUCCPLC::AddPieShape(long xStart, long yStart, long xEnd, long yEnd, long ptXStart, long ptYStart, long ptXEnd, long ptYEnd)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4;
	InvokeHelper(0xde, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		xStart, yStart, xEnd, yEnd, ptXStart, ptYStart, ptXEnd, ptYEnd);
	return result;
}

long CDUCCPLC::AddEllipseChordShape(long xStart, long yStart, long xEnd, long yEnd, long ptXStart, long ptYStart, long ptXEnd, long ptYEnd)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4;
	InvokeHelper(0xdf, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		xStart, yStart, xEnd, yEnd, ptXStart, ptYStart, ptXEnd, ptYEnd);
	return result;
}

long CDUCCPLC::AddArcLine2Shape(long xStart, long yStart, long xEnd, long yEnd, long ptXStart, long ptYStart, long ptXEnd, long ptYEnd, BOOL bArrow)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_BOOL;
	InvokeHelper(0xe0, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		xStart, yStart, xEnd, yEnd, ptXStart, ptYStart, ptXEnd, ptYEnd, bArrow);
	return result;
}

void CDUCCPLC::SetHlpLineVisible(BOOL bVisible)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0xe1, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bVisible);
}

void CDUCCPLC::DoDrawArcLine2()
{
	InvokeHelper(0xe2, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::DoDrawEllipseChord()
{
	InvokeHelper(0xe3, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::DoMirrorFree()
{
	InvokeHelper(0xe4, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::DoRemoveHlpLine()
{
	InvokeHelper(0xe5, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::DoShowPosAndSizeDlg()
{
	InvokeHelper(0xe6, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::ExportAsBitmapFile(LPCTSTR strFile)
{
	static BYTE parms[] =
		VTS_BSTR;
	InvokeHelper(0xe7, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		strFile);
}

void CDUCCPLC::ExportAsEMFFile(LPCTSTR strFile)
{
	static BYTE parms[] =
		VTS_BSTR;
	InvokeHelper(0xe8, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		strFile);
}

long CDUCCPLC::AddExtLineShape(long xStart, long yStart, long xEnd, long yEnd, BOOL bArrow)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_BOOL;
	InvokeHelper(0xe9, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		xStart, yStart, xEnd, yEnd, bArrow);
	return result;
}

long CDUCCPLC::AddHorzDimLineShape(long xStart, long yStart, long xEnd, long yEnd, long nWidth, BOOL bArrow)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_BOOL;
	InvokeHelper(0xea, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		xStart, yStart, xEnd, yEnd, nWidth, bArrow);
	return result;
}

long CDUCCPLC::AddVertDimLineShape(long xStart, long yStart, long xEnd, long yEnd, long nWidth, BOOL bArrow)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_BOOL;
	InvokeHelper(0xeb, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		xStart, yStart, xEnd, yEnd, nWidth, bArrow);
	return result;
}

long CDUCCPLC::AddRadiusDimLineShape(long xStart, long yStart, long xEnd, long yEnd, long nWidth, BOOL bArrow)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_BOOL;
	InvokeHelper(0xec, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		xStart, yStart, xEnd, yEnd, nWidth, bArrow);
	return result;
}

long CDUCCPLC::AddCaptionShape(long xStart, long yStart, long xEnd, long yEnd, long nWidth, long nHeight, BOOL bArrow)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_BOOL;
	InvokeHelper(0xed, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		xStart, yStart, xEnd, yEnd, nWidth, nHeight, bArrow);
	return result;
}

long CDUCCPLC::AddRectCalloutShape(long xStart, long yStart, long xEnd, long yEnd, long nWidth, long nHeight)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4;
	InvokeHelper(0xee, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		xStart, yStart, xEnd, yEnd, nWidth, nHeight);
	return result;
}

long CDUCCPLC::AddRoundCalloutShape(long xStart, long yStart, long xEnd, long yEnd, long nWidth, long nHeight)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4;
	InvokeHelper(0xef, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		xStart, yStart, xEnd, yEnd, nWidth, nHeight);
	return result;
}

long CDUCCPLC::AddCloudCalloutShape(long xStart, long yStart, long xEnd, long yEnd, long nWidth, long nHeight)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4;
	InvokeHelper(0xf0, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		xStart, yStart, xEnd, yEnd, nWidth, nHeight);
	return result;
}

BOOL CDUCCPLC::IsHlpLineVisible()
{
	BOOL result;
	InvokeHelper(0xf1, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

BOOL CDUCCPLC::IsEnableSnapToHelpLine()
{
	BOOL result;
	InvokeHelper(0xf2, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCPLC::EnableSnapToHelpLine(BOOL bEnable)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0xf3, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bEnable);
}

BOOL CDUCCPLC::IsEnableSnapToControlHandle()
{
	BOOL result;
	InvokeHelper(0xf4, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCPLC::EnableSnapToControlHandle(BOOL bEnable)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0xf5, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bEnable);
}

BOOL CDUCCPLC::IsEnableSnapToSpot()
{
	BOOL result;
	InvokeHelper(0xf6, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCPLC::EnableSnapToSpot(BOOL bEnable)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0xf7, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bEnable);
}

BOOL CDUCCPLC::IsEnableSnapToIntersectPoint()
{
	BOOL result;
	InvokeHelper(0xf8, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCPLC::EnableSnapToIntersectPoint(BOOL bEnable)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0xf9, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bEnable);
}

BOOL CDUCCPLC::IsCenterDrawAllowed()
{
	BOOL result;
	InvokeHelper(0xfa, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCPLC::EnableCenterDraw(BOOL bEnable)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0xfb, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bEnable);
}

void CDUCCPLC::DoDrawCaptionline()
{
	InvokeHelper(0xfc, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::DoDrawRectCallout()
{
	InvokeHelper(0xfd, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::DoDrawRoundCallout()
{
	InvokeHelper(0xfe, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::DoDrawCloudCallout()
{
	InvokeHelper(0xff, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::DoDrawHorzDimline()
{
	InvokeHelper(0x100, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::DoDrawVertDimline()
{
	InvokeHelper(0x101, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::DoDrawRadiusDimline()
{
	InvokeHelper(0x102, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::DoDrawExtLine()
{
	InvokeHelper(0x103, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::DoReverseOrder()
{
	InvokeHelper(0x104, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::DoInfrontShape()
{
	InvokeHelper(0x105, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::DoBehindShape()
{
	InvokeHelper(0x106, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

BOOL CDUCCPLC::IsRulerVisible()
{
	BOOL result;
	InvokeHelper(0x107, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCPLC::ShowRulers(BOOL bVisible)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0x108, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bVisible);
}

void CDUCCPLC::SetRulerUnit(short nType)
{
	static BYTE parms[] =
		VTS_I2;
	InvokeHelper(0x109, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		nType);
}

void CDUCCPLC::DoPutShapeToBack()
{
	InvokeHelper(0x10a, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::DoFoPolyInsertpoint()
{
	InvokeHelper(0x10b, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

BOOL CDUCCPLC::IsAllowInsertPoint()
{
	BOOL result;
	InvokeHelper(0x10c, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCPLC::DoFoPolyDeletepoint()
{
	InvokeHelper(0x10d, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

BOOL CDUCCPLC::IsAllowDeletePoint()
{
	BOOL result;
	InvokeHelper(0x10e, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCPLC::DoConvertSegmentToline()
{
	InvokeHelper(0x10f, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

BOOL CDUCCPLC::IsAllowConvertSegmentToLine()
{
	BOOL result;
	InvokeHelper(0x110, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCPLC::DoConvertSegmentToCurve()
{
	InvokeHelper(0x111, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

BOOL CDUCCPLC::IsAllowConvertSegmentToCurve()
{
	BOOL result;
	InvokeHelper(0x112, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCPLC::DoRipUpPoint()
{
	InvokeHelper(0x113, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

BOOL CDUCCPLC::IsAllowRipUpPoint()
{
	BOOL result;
	InvokeHelper(0x114, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCPLC::DoDrawTurnCornerLinkLine()
{
	InvokeHelper(0x115, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::DoDrawBreakCenterLinkLine()
{
	InvokeHelper(0x116, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::DoEllipseSelect()
{
	InvokeHelper(0x117, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::DoConvertToPath()
{
	InvokeHelper(0x118, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

BOOL CDUCCPLC::IsAllowConvertToPath()
{
	BOOL result;
	InvokeHelper(0x119, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCPLC::DoConvertToPoly()
{
	InvokeHelper(0x11a, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

BOOL CDUCCPLC::IsAllowConvertToPoly()
{
	BOOL result;
	InvokeHelper(0x11b, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCPLC::DoShapesCombine()
{
	InvokeHelper(0x11c, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

BOOL CDUCCPLC::IsAllowShapeCombine()
{
	BOOL result;
	InvokeHelper(0x11d, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCPLC::DoShapesDismantle()
{
	InvokeHelper(0x11e, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

BOOL CDUCCPLC::IsAllowShapeDismantle()
{
	BOOL result;
	InvokeHelper(0x11f, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCPLC::DoShapesMergeMerge()
{
	InvokeHelper(0x120, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

BOOL CDUCCPLC::IsAllowShapeMergeMerge()
{
	BOOL result;
	InvokeHelper(0x121, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCPLC::DoShapesMergeSubstract()
{
	InvokeHelper(0x122, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

BOOL CDUCCPLC::IsAllowShapeMergeSubstract()
{
	BOOL result;
	InvokeHelper(0x123, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCPLC::DoShapesMergeIntersect()
{
	InvokeHelper(0x124, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

BOOL CDUCCPLC::IsAllowShapeMergeIntersect()
{
	BOOL result;
	InvokeHelper(0x125, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCPLC::DoConnectLines()
{
	InvokeHelper(0x126, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

BOOL CDUCCPLC::IsAllowConnectLines()
{
	BOOL result;
	InvokeHelper(0x127, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCPLC::DoBreakShapeToLines()
{
	InvokeHelper(0x128, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

BOOL CDUCCPLC::IsAllowBreakShapeToLines()
{
	BOOL result;
	InvokeHelper(0x129, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCPLC::DoCloseShape()
{
	InvokeHelper(0x12a, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

BOOL CDUCCPLC::IsAllowCloseShape()
{
	BOOL result;
	InvokeHelper(0x12b, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCPLC::DoShearFree()
{
	InvokeHelper(0x12c, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

BOOL CDUCCPLC::IsAllowShearFree()
{
	BOOL result;
	InvokeHelper(0x12d, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

BOOL CDUCCPLC::IsEllipseSelectMode()
{
	BOOL result;
	InvokeHelper(0x12e, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCPLC::ConnectSelectShapes()
{
	InvokeHelper(0x12f, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::DoGenCreateLink()
{
	InvokeHelper(0x130, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::AddToSelection(long shape)
{
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x131, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape);
}

void CDUCCPLC::RemoveShape(long shape)
{
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x132, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape);
}

BOOL CDUCCPLC::GetShapeBoolProp(long shape, long nPropID)
{
	BOOL result;
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x133, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms,
		shape, nPropID);
	return result;
}

CString CDUCCPLC::GetShapeStringProp(long shape, long nPropID)
{
	CString result;
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x134, DISPATCH_METHOD, VT_BSTR, (void*)&result, parms,
		shape, nPropID);
	return result;
}

long CDUCCPLC::GetShapeIntProp(long shape, long nPropID)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x135, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		shape, nPropID);
	return result;
}

short CDUCCPLC::GetShapeUINTProp(long shape, long nPropID)
{
	short result;
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x136, DISPATCH_METHOD, VT_I2, (void*)&result, parms,
		shape, nPropID);
	return result;
}

float CDUCCPLC::GetShapeFloatProp(long shape, long nPropID)
{
	float result;
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x137, DISPATCH_METHOD, VT_R4, (void*)&result, parms,
		shape, nPropID);
	return result;
}

double CDUCCPLC::GetShapeDoubleProp(long shape, long nPropID)
{
	double result;
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x138, DISPATCH_METHOD, VT_R8, (void*)&result, parms,
		shape, nPropID);
	return result;
}

DATE CDUCCPLC::GetShapeDateTimeProp(long shape, long nPropID)
{
	DATE result;
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x139, DISPATCH_METHOD, VT_DATE, (void*)&result, parms,
		shape, nPropID);
	return result;
}

long CDUCCPLC::GetShapeColorProp(long shape, long nPropID)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x13a, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		shape, nPropID);
	return result;
}

long CDUCCPLC::GetShapeDwordProp(long shape, long nPropID)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x13b, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		shape, nPropID);
	return result;
}

long CDUCCPLC::ConnectTwoShapes(long shapefirst, long shapesecond)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x13c, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		shapefirst, shapesecond);
	return result;
}

BOOL CDUCCPLC::IsStaticShape(long shape)
{
	BOOL result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x13d, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms,
		shape);
	return result;
}

BOOL CDUCCPLC::IsShapeLinked(long shape)
{
	BOOL result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x13e, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms,
		shape);
	return result;
}

long CDUCCPLC::GetBoundXPos(long shape)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x13f, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		shape);
	return result;
}

long CDUCCPLC::GetBoundYPos(long shape)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x140, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		shape);
	return result;
}

long CDUCCPLC::GetBoundWidth(long shape)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x141, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		shape);
	return result;
}

long CDUCCPLC::GetBoundHeight(long shape)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x142, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		shape);
	return result;
}

long CDUCCPLC::GetSnapXPos(long shape)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x143, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		shape);
	return result;
}

long CDUCCPLC::GetSnapYPos(long shape)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x144, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		shape);
	return result;
}

long CDUCCPLC::GetSnapWidth(long shape)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x145, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		shape);
	return result;
}

long CDUCCPLC::GetSnapHeight(long shape)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x146, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		shape);
	return result;
}

BOOL CDUCCPLC::IsPolyObject(long shape)
{
	BOOL result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x147, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms,
		shape);
	return result;
}

void CDUCCPLC::SetInitRotateAngle(long shape, long angle)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x148, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, angle);
}

void CDUCCPLC::UpdateComp(long shape)
{
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x149, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape);
}

BOOL CDUCCPLC::IsShapeClosed(long shape)
{
	BOOL result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x14a, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms,
		shape);
	return result;
}

void CDUCCPLC::SetWithLabelShow(long shape, BOOL allow)
{
	static BYTE parms[] =
		VTS_I4 VTS_BOOL;
	InvokeHelper(0x14b, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, allow);
}

void CDUCCPLC::SetWithLabelEditing(long shape, BOOL allow)
{
	static BYTE parms[] =
		VTS_I4 VTS_BOOL;
	InvokeHelper(0x14c, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, allow);
}

BOOL CDUCCPLC::IsLinkShape(long shape)
{
	BOOL result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x14d, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms,
		shape);
	return result;
}

BOOL CDUCCPLC::IsCompositeShape(long shape)
{
	BOOL result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x14e, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms,
		shape);
	return result;
}

BOOL CDUCCPLC::IsGroupShape(long shape)
{
	BOOL result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x14f, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms,
		shape);
	return result;
}

BOOL CDUCCPLC::IsKindShape(long shape, long Type)
{
	BOOL result;
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x150, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms,
		shape, Type);
	return result;
}

long CDUCCPLC::GetSelectionCount()
{
	long result;
	InvokeHelper(0x151, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
	return result;
}

long CDUCCPLC::GetSelection(long index)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x152, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		index);
	return result;
}

long CDUCCPLC::GetShapeAt(long index)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x153, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		index);
	return result;
}

long CDUCCPLC::GetCompositeShapeChildCount(long shapecomposite)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x154, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		shapecomposite);
	return result;
}

long CDUCCPLC::GetCompositeShapeAt(long compositeshape, long index)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x155, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		compositeshape, index);
	return result;
}

long CDUCCPLC::GetPortsShapePortCount(long portsshape)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x156, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		portsshape);
	return result;
}

long CDUCCPLC::GetPortsShapePortShapeAt(long portsshape, long index)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x157, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		portsshape, index);
	return result;
}

long CDUCCPLC::GetPortLinkCount(long portshape)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x158, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		portshape);
	return result;
}

long CDUCCPLC::GetPortLinkShapeAt(long portshape, long index)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x159, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		portshape, index);
	return result;
}

long CDUCCPLC::GetLinkFromShape(long link)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x15a, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		link);
	return result;
}

long CDUCCPLC::GetLinkToShape(long link)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x15b, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		link);
	return result;
}

void CDUCCPLC::RemoveCurShapeToSelection(long shape)
{
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x15c, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape);
}

BOOL CDUCCPLC::IsShapeSelected(long shape)
{
	BOOL result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x15d, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms,
		shape);
	return result;
}

BOOL CDUCCPLC::IsPortShape(long shape)
{
	BOOL result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x15e, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms,
		shape);
	return result;
}

long CDUCCPLC::AddDefaultPort(long portsshape, double xScale, double yScale)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_R8 VTS_R8;
	InvokeHelper(0x15f, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		portsshape, xScale, yScale);
	return result;
}

long CDUCCPLC::ConnectWithTwoPorts(long portFirst, long portSecond)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x160, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		portFirst, portSecond);
	return result;
}

void CDUCCPLC::FlashShape(long shape, short times)
{
	static BYTE parms[] =
		VTS_I4 VTS_I2;
	InvokeHelper(0x161, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, times);
}

long CDUCCPLC::GetMaxUndoActionCount()
{
	long result;
	InvokeHelper(0x162, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
	return result;
}

long CDUCCPLC::GetMaxRedoActionCount()
{
	long result;
	InvokeHelper(0x163, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
	return result;
}

void CDUCCPLC::SetMaxUndoActionCount(short Count)
{
	static BYTE parms[] =
		VTS_I2;
	InvokeHelper(0x164, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		Count);
}

void CDUCCPLC::SetMaxRedoActionCount(short Count)
{
	static BYTE parms[] =
		VTS_I2;
	InvokeHelper(0x165, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		Count);
}

void CDUCCPLC::ChangeRulerUnit(short unit)
{
	static BYTE parms[] =
		VTS_I2;
	InvokeHelper(0x166, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		unit);
}

void CDUCCPLC::SelectShape(long shape)
{
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x167, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape);
}

long CDUCCPLC::GetBackgroundShapeCount()
{
	long result;
	InvokeHelper(0x168, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
	return result;
}

long CDUCCPLC::GetBackShapeAt(long index)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x169, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		index);
	return result;
}

void CDUCCPLC::AddShapeToBack(long shape)
{
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x16a, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape);
}

void CDUCCPLC::RemoveShapeFromBack(long shape)
{
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x16b, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape);
}

void CDUCCPLC::RemoveAllShapesFromBack()
{
	InvokeHelper(0x16c, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

long CDUCCPLC::FindShapeWithNameFromBack(LPCTSTR Name)
{
	long result;
	static BYTE parms[] =
		VTS_BSTR;
	InvokeHelper(0x16d, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		Name);
	return result;
}

long CDUCCPLC::CloneShape(long shape)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x16e, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		shape);
	return result;
}

void CDUCCPLC::RemoveAllPorts(long portsshape)
{
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x16f, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		portsshape);
}

long CDUCCPLC::GetShapePointCount(long shape)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x170, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		shape);
	return result;
}

long CDUCCPLC::GetShapePointXAt(long shape, long index)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x171, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		shape, index);
	return result;
}

long CDUCCPLC::GetShapePointYAt(long shape, long index)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x172, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		shape, index);
	return result;
}

void CDUCCPLC::AddShapePoint(long shape, long x, long y)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4;
	InvokeHelper(0x173, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, x, y);
}

void CDUCCPLC::RemoveShapePoint(long shape, long index)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x174, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, index);
}

void CDUCCPLC::InsertShapePoint(long shape, long index, long x, long y)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4 VTS_I4;
	InvokeHelper(0x175, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, index, x, y);
}

void CDUCCPLC::SetShapePointAt(long shape, long index, long x, long y)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4 VTS_I4;
	InvokeHelper(0x176, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, index, x, y);
}

BOOL CDUCCPLC::IsToolBoxVisible()
{
	BOOL result;
	InvokeHelper(0x177, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCPLC::ShowToolBoxWindow(BOOL bShow)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0x178, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bShow);
}

void CDUCCPLC::RomoveToolBoxPage(long index)
{
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x179, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		index);
}

long CDUCCPLC::GetToolBoxPageCount()
{
	long result;
	InvokeHelper(0x17a, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
	return result;
}

void CDUCCPLC::EnableToolboxEditProp(BOOL bEnable)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0x17b, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bEnable);
}

long CDUCCPLC::FODPtoLPX(long xInput)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x17c, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		xInput);
	return result;
}

long CDUCCPLC::FODPtoLPY(long yInput)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x17d, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		yInput);
	return result;
}

long CDUCCPLC::FOLPtoDPX(short xInput)
{
	long result;
	static BYTE parms[] =
		VTS_I2;
	InvokeHelper(0x17e, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		xInput);
	return result;
}

long CDUCCPLC::FOLPtoDPY(long yInput)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x17f, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		yInput);
	return result;
}

void CDUCCPLC::EnableUniqueCaption(BOOL bEnable)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0x180, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bEnable);
}

void CDUCCPLC::EnableUniqueName(BOOL bEnable)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0x181, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bEnable);
}

long CDUCCPLC::GetPortParentShape(long portshape)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x182, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		portshape);
	return result;
}

long CDUCCPLC::CreateShape(short nType, short xLeft, short yTop, short xRight, short yBottom, LPCTSTR lpszFileName)
{
	long result;
	static BYTE parms[] =
		VTS_I2 VTS_I2 VTS_I2 VTS_I2 VTS_I2 VTS_BSTR;
	InvokeHelper(0x183, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		nType, xLeft, yTop, xRight, yBottom, lpszFileName);
	return result;
}

void CDUCCPLC::AddListField(long listshape, short index, BOOL bshowleftport, BOOL bshowrightport, LPCTSTR strfield)
{
	static BYTE parms[] =
		VTS_I4 VTS_I2 VTS_BOOL VTS_BOOL VTS_BSTR;
	InvokeHelper(0x184, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		listshape, index, bshowleftport, bshowrightport, strfield);
}

void CDUCCPLC::UpdateShapeGeo(long shape)
{
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x185, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape);
}

long CDUCCPLC::FindPortFromIndex(long listshape, short index, BOOL bLeftPort)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I2 VTS_BOOL;
	InvokeHelper(0x186, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		listshape, index, bLeftPort);
	return result;
}

long CDUCCPLC::LinkTwoField(long FromPort, long ToPort)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x187, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		FromPort, ToPort);
	return result;
}

long CDUCCPLC::GetFieldCountOfListCtrl(long listshape)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x188, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		listshape);
	return result;
}

CString CDUCCPLC::GetFieldCaption(long listshape, short index)
{
	CString result;
	static BYTE parms[] =
		VTS_I4 VTS_I2;
	InvokeHelper(0x189, DISPATCH_METHOD, VT_BSTR, (void*)&result, parms,
		listshape, index);
	return result;
}

void CDUCCPLC::DoDrawImageNode(LPDISPATCH iPictureDisp)
{
	static BYTE parms[] =
		VTS_DISPATCH;
	InvokeHelper(0x18a, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		iPictureDisp);
}

long CDUCCPLC::AddImageNode(short x, short y, LPDISPATCH iPictureDisp)
{
	long result;
	static BYTE parms[] =
		VTS_I2 VTS_I2 VTS_DISPATCH;
	InvokeHelper(0x18b, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		x, y, iPictureDisp);
	return result;
}

void CDUCCPLC::EnableContinueDraw(BOOL bEnable)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0x18c, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bEnable);
}

void CDUCCPLC::DoMakeSubgraph()
{
	InvokeHelper(0x18d, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::UnGroupSubgraph()
{
	InvokeHelper(0x18e, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::DoVCPrintPreview()
{
	InvokeHelper(0x18f, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::ChangeToolBoxBackColor(long crFirst, long crLast)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x190, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		crFirst, crLast);
}

BOOL CDUCCPLC::GetModelBoolProp(long nPropID)
{
	BOOL result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x191, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms,
		nPropID);
	return result;
}

CString CDUCCPLC::GetModelStringProp(long nPropID)
{
	CString result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x192, DISPATCH_METHOD, VT_BSTR, (void*)&result, parms,
		nPropID);
	return result;
}

long CDUCCPLC::GetModelIntProp(long nPropID)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x193, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		nPropID);
	return result;
}

float CDUCCPLC::GetModelFloatProp(long nPropID)
{
	float result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x194, DISPATCH_METHOD, VT_R4, (void*)&result, parms,
		nPropID);
	return result;
}

double CDUCCPLC::GetModelDoubleProp(long nPropID)
{
	double result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x195, DISPATCH_METHOD, VT_R8, (void*)&result, parms,
		nPropID);
	return result;
}

DATE CDUCCPLC::GetModelDateTimeProp(long nPropID)
{
	DATE result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x196, DISPATCH_METHOD, VT_DATE, (void*)&result, parms,
		nPropID);
	return result;
}

long CDUCCPLC::GetModelColorProp(float nPropID)
{
	long result;
	static BYTE parms[] =
		VTS_R4;
	InvokeHelper(0x197, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		nPropID);
	return result;
}

long CDUCCPLC::GetModelDWordProp(long nPropID)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x198, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		nPropID);
	return result;
}

void CDUCCPLC::DoDrawEllipse2()
{
	InvokeHelper(0x199, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

long CDUCCPLC::AddEllipse2Shape(long xLeft, long yTop, long xRight, long yBottom, LPCTSTR lpszCaption)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_BSTR;
	InvokeHelper(0x19a, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		xLeft, yTop, xRight, yBottom, lpszCaption);
	return result;
}

void CDUCCPLC::DoDrawNewBizerLine()
{
	InvokeHelper(0x19b, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::EnterEditingBack()
{
	InvokeHelper(0x19c, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::EndEditingBack()
{
	InvokeHelper(0x19d, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

BOOL CDUCCPLC::IsModified()
{
	BOOL result;
	InvokeHelper(0x19e, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCPLC::DoAutoReroute()
{
	InvokeHelper(0x19f, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

long CDUCCPLC::AddSimplePathShape(long xStart, long yStart, long xEnd, long yEnd, short nType)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I2;
	InvokeHelper(0x1a0, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		xStart, yStart, xEnd, yEnd, nType);
	return result;
}

void CDUCCPLC::EnableFreeFormDrawing(BOOL bEnable)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0x1a1, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bEnable);
}

BOOL CDUCCPLC::IsFreeFormDrawing()
{
	BOOL result;
	InvokeHelper(0x1a2, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

BOOL CDUCCPLC::IsEnableSnapDynGrid()
{
	BOOL result;
	InvokeHelper(0x1a3, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCPLC::EnableSnapDynGrid(BOOL bEnable)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0x1a4, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bEnable);
}

void CDUCCPLC::EnableSnapAidLine(BOOL bEnable)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0x1a5, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bEnable);
}

BOOL CDUCCPLC::IsEnableSnapAidLine()
{
	BOOL result;
	InvokeHelper(0x1a6, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCPLC::ShowColorThemeDlg()
{
	InvokeHelper(0x1a7, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::DoDrawCurveLink()
{
	InvokeHelper(0x1a8, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::DoDrawRoundCornerLinkLine()
{
	InvokeHelper(0x1a9, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::MoveShapeTo(long shape, long xPos, long yPos)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4;
	InvokeHelper(0x1aa, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, xPos, yPos);
}

void CDUCCPLC::SetShapeDimension(long shape, long Width, long Height)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4;
	InvokeHelper(0x1ab, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, Width, Height);
}

BOOL CDUCCPLC::GetShapeShowLabelAtFirst(long shape)
{
	BOOL result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x1ac, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms,
		shape);
	return result;
}

void CDUCCPLC::SetShapeShowLabelAtFirst(long shape, BOOL bShow)
{
	static BYTE parms[] =
		VTS_I4 VTS_BOOL;
	InvokeHelper(0x1ad, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, bShow);
}

BOOL CDUCCPLC::GetShapeWithLabelShow(long shape)
{
	BOOL result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x1ae, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms,
		shape);
	return result;
}

void CDUCCPLC::SetShapeWithLabelShow(long shape, BOOL bShow)
{
	static BYTE parms[] =
		VTS_I4 VTS_BOOL;
	InvokeHelper(0x1af, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, bShow);
}

BOOL CDUCCPLC::GetShapeWithLabelEditing(long shape)
{
	BOOL result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x1b0, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms,
		shape);
	return result;
}

void CDUCCPLC::SetShapeWithLabelEditing(long shape, BOOL bEnable)
{
	static BYTE parms[] =
		VTS_I4 VTS_BOOL;
	InvokeHelper(0x1b1, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, bEnable);
}

void CDUCCPLC::MPreparePtAry()
{
	InvokeHelper(0x1b2, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::MAddPtToAry(long xPoint, long yPoint)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x1b3, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		xPoint, yPoint);
}

long CDUCCPLC::AddPolylineShape(LPCTSTR strCaption)
{
	long result;
	static BYTE parms[] =
		VTS_BSTR;
	InvokeHelper(0x1b4, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		strCaption);
	return result;
}

long CDUCCPLC::MAddPolygonShape(LPCTSTR strCaption)
{
	long result;
	static BYTE parms[] =
		VTS_BSTR;
	InvokeHelper(0x1b5, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		strCaption);
	return result;
}

long CDUCCPLC::MAddBezierLineShape(LPCTSTR strCaption)
{
	long result;
	static BYTE parms[] =
		VTS_BSTR;
	InvokeHelper(0x1b6, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		strCaption);
	return result;
}

long CDUCCPLC::MAddCloseBezierLineShape(LPCTSTR strCaption)
{
	long result;
	static BYTE parms[] =
		VTS_BSTR;
	InvokeHelper(0x1b7, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		strCaption);
	return result;
}

long CDUCCPLC::MAddExtBezierLineShape(LPCTSTR strCaption)
{
	long result;
	static BYTE parms[] =
		VTS_BSTR;
	InvokeHelper(0x1b8, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		strCaption);
	return result;
}

void CDUCCPLC::MAddLinkShape(short nLinkType, long FromPort, long ToPort, short arrowtype)
{
	static BYTE parms[] =
		VTS_I2 VTS_I4 VTS_I4 VTS_I2;
	InvokeHelper(0x1b9, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		nLinkType, FromPort, ToPort, arrowtype);
}

long CDUCCPLC::GetShapeCenterPort(long shape)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x1ba, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		shape);
	return result;
}

void CDUCCPLC::SetApplicationName(LPCTSTR pszAppName)
{
	static BYTE parms[] =
		VTS_BSTR;
	InvokeHelper(0x1bb, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		pszAppName);
}

BOOL CDUCCPLC::FindShapeWithinDataModel(long shape)
{
	BOOL result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x1bc, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms,
		shape);
	return result;
}

BOOL CDUCCPLC::AddBoolUserProperty(long shape, long nPropID, BOOL bValue)
{
	BOOL result;
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_BOOL;
	InvokeHelper(0x1bd, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms,
		shape, nPropID, bValue);
	return result;
}

BOOL CDUCCPLC::AddStringUserProperty(long shape, long nPropID, LPCTSTR strValue)
{
	BOOL result;
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_BSTR;
	InvokeHelper(0x1be, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms,
		shape, nPropID, strValue);
	return result;
}

BOOL CDUCCPLC::AddIntUserProperty(long shape, long nPropID, long nValue)
{
	BOOL result;
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4;
	InvokeHelper(0x1bf, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms,
		shape, nPropID, nValue);
	return result;
}

BOOL CDUCCPLC::AddFloatUserProperty(long shape, long nPropID, float fValue)
{
	BOOL result;
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_R4;
	InvokeHelper(0x1c0, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms,
		shape, nPropID, fValue);
	return result;
}

BOOL CDUCCPLC::AddDoubleUserProperty(long shape, long nPropID, double dValue)
{
	BOOL result;
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_R8;
	InvokeHelper(0x1c1, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms,
		shape, nPropID, dValue);
	return result;
}

BOOL CDUCCPLC::AddDateUserProperty(long shape, long nPropID, DATE dtTime)
{
	BOOL result;
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_DATE;
	InvokeHelper(0x1c2, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms,
		shape, nPropID, dtTime);
	return result;
}

BOOL CDUCCPLC::AddColorUserProperty(long shape, long nPropID, long crColor)
{
	BOOL result;
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4;
	InvokeHelper(0x1c3, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms,
		shape, nPropID, crColor);
	return result;
}

BOOL CDUCCPLC::AddDWordUserProperty(long shape, long nPropID, long dwData)
{
	BOOL result;
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4;
	InvokeHelper(0x1c4, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms,
		shape, nPropID, dwData);
	return result;
}

void CDUCCPLC::ChangeShapeBoolWithoutUndo(long shape, long nPropID, BOOL bValue)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_BOOL;
	InvokeHelper(0x1c5, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, nPropID, bValue);
}

void CDUCCPLC::ChangeShapeStringWithoutUndo(long shape, long nPropID, LPCTSTR strValue)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_BSTR;
	InvokeHelper(0x1c6, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, nPropID, strValue);
}

void CDUCCPLC::ChangeShapeIntWithoutUndo(long shape, long nPropID, long nValue)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4;
	InvokeHelper(0x1c7, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, nPropID, nValue);
}

void CDUCCPLC::ChangeShapeFloatWithoutUndo(long shape, long nPropID, float fValue)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_R4;
	InvokeHelper(0x1c8, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, nPropID, fValue);
}

void CDUCCPLC::ChangeShapeDoubleWithoutUndo(long shape, long nPropID, double dValue)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_R8;
	InvokeHelper(0x1c9, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, nPropID, dValue);
}

void CDUCCPLC::ChangeShapeDWordWithoutUndo(long shape, long nPropID, long dwValue)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4;
	InvokeHelper(0x1ca, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, nPropID, dwValue);
}

void CDUCCPLC::ChangeShapeColorWithoutUndo(long shape, long nPropID, long crColor)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4;
	InvokeHelper(0x1cb, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, nPropID, crColor);
}

void CDUCCPLC::ChangeShapeDateWithoutUndo(long shape, long nPropID, DATE dtValue)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_DATE;
	InvokeHelper(0x1cc, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, nPropID, dtValue);
}

long CDUCCPLC::GetLinkCount()
{
	long result;
	InvokeHelper(0x1cd, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
	return result;
}

long CDUCCPLC::GetLinkAt(long nIndex)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x1ce, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		nIndex);
	return result;
}

long CDUCCPLC::GetSelectedLinkCount()
{
	long result;
	InvokeHelper(0x1cf, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
	return result;
}

long CDUCCPLC::GetSelectedLinkAt(long index)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x1d0, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		index);
	return result;
}

void CDUCCPLC::RemoveShapeWithoutUndo(long shape)
{
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x1d1, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape);
}

long CDUCCPLC::GetShapeLinksCount(long node)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x1d2, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		node);
	return result;
}

long CDUCCPLC::GetShapeLinksAtIndex(long node, long index)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x1d3, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		node, index);
	return result;
}

long CDUCCPLC::GetShapeFromLinksCount(long shape)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x1d4, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		shape);
	return result;
}

long CDUCCPLC::GetShapeFromLinksAtIndex(long node, long index)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x1d5, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		node, index);
	return result;
}

long CDUCCPLC::GetShapeToLinksCount(long shape)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x1d6, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		shape);
	return result;
}

long CDUCCPLC::GetShapeToLinksAtIndex(long node, long index)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x1d7, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		node, index);
	return result;
}

long CDUCCPLC::GetDirectLinkedShapeCount(long node)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x1d8, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		node);
	return result;
}

long CDUCCPLC::GetDirectLinkedShapeAt(long node, long index)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x1d9, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		node, index);
	return result;
}

long CDUCCPLC::GetDirectLinkedFromShapeCount(long node)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x1da, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		node);
	return result;
}

long CDUCCPLC::GetDirectLinkedFromShapeAt(long node, long index)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x1db, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		node, index);
	return result;
}

long CDUCCPLC::GetDirectLinkedToShapeCount(long node)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x1dc, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		node);
	return result;
}

long CDUCCPLC::GetDirectLinkedToShapeAt(long node, long index)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x1dd, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		node, index);
	return result;
}

long CDUCCPLC::GetAllLinkedShapeCount(long node)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x1de, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		node);
	return result;
}

long CDUCCPLC::GetAllLinkedShapeAt(long node, long index)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x1df, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		node, index);
	return result;
}

long CDUCCPLC::GetAllLinkedFromShapeAt(long node, long index)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x1e0, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		node, index);
	return result;
}

long CDUCCPLC::GetAllLinkedFromShapeCount(long node)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x1e1, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		node);
	return result;
}

long CDUCCPLC::GetAllLinkedToShapeCount(long node)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x1e2, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		node);
	return result;
}

long CDUCCPLC::GetAllLinkedToShapeAt(long node, long index)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x1e3, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		node, index);
	return result;
}

long CDUCCPLC::GetFocusShape()
{
	long result;
	InvokeHelper(0x1e4, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
	return result;
}

long CDUCCPLC::AddLinkShapeNoUndo(long FromNode, long ToNode, short LinkType, short arrowtype)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I2 VTS_I2;
	InvokeHelper(0x1e5, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		FromNode, ToNode, LinkType, arrowtype);
	return result;
}

void CDUCCPLC::ChangeToolBoxIndexFile(LPCTSTR strNewFile)
{
	static BYTE parms[] =
		VTS_BSTR;
	InvokeHelper(0x1e6, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		strNewFile);
}

void CDUCCPLC::DoShowProtDlg()
{
	InvokeHelper(0x1e7, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

long CDUCCPLC::SaveToImage()
{
	long result;
	InvokeHelper(0x1e8, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
	return result;
}

long CDUCCPLC::LoadFromImage(long hEmf, short xStart, short yStart)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I2 VTS_I2;
	InvokeHelper(0x1e9, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		hEmf, xStart, yStart);
	return result;
}

void CDUCCPLC::EndTextBoxEdit()
{
	InvokeHelper(0x1ea, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::EndEditBoxEdit()
{
	InvokeHelper(0x1eb, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::EndComboBoxEdit()
{
	InvokeHelper(0x1ec, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::StartRichTextEdit(long richshape)
{
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x1ed, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		richshape);
}

long CDUCCPLC::SaveMemory(long* xlen)
{
	long result;
	static BYTE parms[] =
		VTS_PI4;
	InvokeHelper(0x1ee, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		xlen);
	return result;
}

void CDUCCPLC::LoadMemory(long hMem, long* xlen)
{
	static BYTE parms[] =
		VTS_I4 VTS_PI4;
	InvokeHelper(0x1ef, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		hMem, xlen);
}

BOOL CDUCCPLC::SaveMemory2(LPCTSTR filename, long pData, long nSize)
{
	BOOL result;
	static BYTE parms[] =
		VTS_BSTR VTS_I4 VTS_I4;
	InvokeHelper(0x1f0, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms,
		filename, pData, nSize);
	return result;
}

long CDUCCPLC::LoadMemory2(LPCTSTR filename, long lpData)
{
	long result;
	static BYTE parms[] =
		VTS_BSTR VTS_I4;
	InvokeHelper(0x1f1, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		filename, lpData);
	return result;
}

void CDUCCPLC::InsertOleShape()
{
	InvokeHelper(0x1f2, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::ShowOpenFileDialog()
{
	InvokeHelper(0x1f3, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::ShowSaveFileDialog()
{
	InvokeHelper(0x1f4, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::ShowTemplateOpenDialog()
{
	InvokeHelper(0x1f5, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::ShowSaveTemplateDialog()
{
	InvokeHelper(0x1f6, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::ShowOptionDialog()
{
	InvokeHelper(0x1f7, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::UpdateAllWindows()
{
	InvokeHelper(0x1f8, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::DoSetDBName()
{
	InvokeHelper(0x1f9, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

long CDUCCPLC::AddBoxShape(long xPos, long yPos, long szWidth, long szHeight, LPCTSTR strCaption)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_BSTR;
	InvokeHelper(0x1fa, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		xPos, yPos, szWidth, szHeight, strCaption);
	return result;
}

long CDUCCPLC::GetShapeType(long shape)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x1fb, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		shape);
	return result;
}

CString CDUCCPLC::GetCurrentText(long shape)
{
	CString result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x1fc, DISPATCH_METHOD, VT_BSTR, (void*)&result, parms,
		shape);
	return result;
}

void CDUCCPLC::SetCurrentText(long shape, LPCTSTR sText)
{
	static BYTE parms[] =
		VTS_I4 VTS_BSTR;
	InvokeHelper(0x1fd, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, sText);
}

BOOL CDUCCPLC::IsEFormShape(long shape)
{
	BOOL result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x1fe, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms,
		shape);
	return result;
}

long CDUCCPLC::GetEFormFocusShape()
{
	long result;
	InvokeHelper(0x1ff, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
	return result;
}

void CDUCCPLC::SetPointLimitWithPage(BOOL bWithIn)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0x200, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bWithIn);
}

void CDUCCPLC::ShowBarCodeLabel(long barcodeshape, BOOL bVisible)
{
	static BYTE parms[] =
		VTS_I4 VTS_BOOL;
	InvokeHelper(0x201, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		barcodeshape, bVisible);
}

void CDUCCPLC::UpdateControl(long shape)
{
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x202, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape);
}

void CDUCCPLC::GetRunTimeInputText()
{
	InvokeHelper(0x203, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::SetFocusOnShape(long shape)
{
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x204, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape);
}

BOOL CDUCCPLC::LoadXdgFromFile(LPCTSTR lpszFileName)
{
	BOOL result;
	static BYTE parms[] =
		VTS_BSTR;
	InvokeHelper(0x205, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms,
		lpszFileName);
	return result;
}

void CDUCCPLC::SaveToXdgFile(LPCTSTR lpszFileName)
{
	static BYTE parms[] =
		VTS_BSTR;
	InvokeHelper(0x206, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		lpszFileName);
}

long CDUCCPLC::FindShapeWithKey1(LPCTSTR strKey)
{
	long result;
	static BYTE parms[] =
		VTS_BSTR;
	InvokeHelper(0x207, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		strKey);
	return result;
}

long CDUCCPLC::FindShapeWithKey2(LPCTSTR strKey)
{
	long result;
	static BYTE parms[] =
		VTS_BSTR;
	InvokeHelper(0x208, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		strKey);
	return result;
}

long CDUCCPLC::FindShapeWithKey3(LPCTSTR strKey)
{
	long result;
	static BYTE parms[] =
		VTS_BSTR;
	InvokeHelper(0x209, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		strKey);
	return result;
}

long CDUCCPLC::FindShapeWithKeyInComp1(long compshape, LPCTSTR strKey)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_BSTR;
	InvokeHelper(0x20a, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		compshape, strKey);
	return result;
}

long CDUCCPLC::FindShapeWithKeyInComp2(long compshape, LPCTSTR strKey)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_BSTR;
	InvokeHelper(0x20b, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		compshape, strKey);
	return result;
}

long CDUCCPLC::FindShapeWithKeyInComp3(long compshape, LPCTSTR strKey)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_BSTR;
	InvokeHelper(0x20c, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		compshape, strKey);
	return result;
}

void CDUCCPLC::RotateFromCenter(long shape, short angle)
{
	static BYTE parms[] =
		VTS_I4 VTS_I2;
	InvokeHelper(0x20d, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, angle);
}

void CDUCCPLC::MoveCenterTo(long shape, long xNew, long yNew)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_I4;
	InvokeHelper(0x20e, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, xNew, yNew);
}

void CDUCCPLC::ScaleFromCenter(long shape, double dX, double dY)
{
	static BYTE parms[] =
		VTS_I4 VTS_R8 VTS_R8;
	InvokeHelper(0x20f, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, dX, dY);
}

void CDUCCPLC::InitLinkTypeAndArrow(short nLinkType, short nArrowType)
{
	static BYTE parms[] =
		VTS_I2 VTS_I2;
	InvokeHelper(0x210, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		nLinkType, nArrowType);
}

long CDUCCPLC::AddShapeWithoutUndo(long shape)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x211, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		shape);
	return result;
}

long CDUCCPLC::GetCanvasWidth2()
{
	long result;
	InvokeHelper(0x212, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
	return result;
}

long CDUCCPLC::GetCanvasHeight2()
{
	long result;
	InvokeHelper(0x213, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
	return result;
}

void CDUCCPLC::ShowPortPinName(BOOL bShow)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0x214, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bShow);
}

void CDUCCPLC::RemoveAllFromSelection(BOOL bRedraw)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0x215, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bRedraw);
}

BOOL CDUCCPLC::DoBendFree()
{
	BOOL result;
	InvokeHelper(0x216, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

BOOL CDUCCPLC::IsAllowBendFree()
{
	BOOL result;
	InvokeHelper(0x217, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCPLC::SelectNewShape(long shape)
{
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x218, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape);
}

void CDUCCPLC::ShowPanWindow(BOOL bShow)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0x219, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bShow);
}

void CDUCCPLC::ShowFileBar(BOOL bShow)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0x21a, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bShow);
}

void CDUCCPLC::ShowDrawBar(BOOL bShow)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0x21b, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bShow);
}

void CDUCCPLC::ShowFontBar(BOOL bShow)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0x21c, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bShow);
}

void CDUCCPLC::ShowFormartBar(BOOL bShow)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0x21d, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bShow);
}

void CDUCCPLC::ShowAlignBar(BOOL bShow)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0x21e, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bShow);
}

void CDUCCPLC::ShowStatusBar(BOOL bShow)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0x21f, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bShow);
}

void CDUCCPLC::ShowLinkBar(BOOL bShow)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0x220, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bShow);
}

void CDUCCPLC::ShowOperatorBar(BOOL bShow)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0x221, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bShow);
}

void CDUCCPLC::SetAllowHoleLink(short bEnable)
{
	static BYTE parms[] =
		VTS_I2;
	InvokeHelper(0x222, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bEnable);
}

BOOL CDUCCPLC::IsPanWindowVisible()
{
	BOOL result;
	InvokeHelper(0x223, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

BOOL CDUCCPLC::IsFileBarVisible()
{
	BOOL result;
	InvokeHelper(0x224, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

BOOL CDUCCPLC::IsDrawBarVisible()
{
	BOOL result;
	InvokeHelper(0x225, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

BOOL CDUCCPLC::IsFontBarVisible()
{
	BOOL result;
	InvokeHelper(0x226, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

BOOL CDUCCPLC::IsFormatBarVisible()
{
	BOOL result;
	InvokeHelper(0x227, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

BOOL CDUCCPLC::IsAlignBarVisible()
{
	BOOL result;
	InvokeHelper(0x228, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

BOOL CDUCCPLC::IsLinkBarVisible()
{
	BOOL result;
	InvokeHelper(0x229, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

BOOL CDUCCPLC::IsOptBarVisible()
{
	BOOL result;
	InvokeHelper(0x22a, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

BOOL CDUCCPLC::IsStatusBarVisible()
{
	BOOL result;
	InvokeHelper(0x22b, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

void CDUCCPLC::DoShowKeyDlg()
{
	InvokeHelper(0x22c, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

double CDUCCPLC::ConvertToMapLog(double dConvertValue, short dUnit, BOOL bVert)
{
	double result;
	static BYTE parms[] =
		VTS_R8 VTS_I2 VTS_BOOL;
	InvokeHelper(0x22d, DISPATCH_METHOD, VT_R8, (void*)&result, parms,
		dConvertValue, dUnit, bVert);
	return result;
}

void CDUCCPLC::OnNewFile()
{
	InvokeHelper(0x22e, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::SetCanvasSize(long szWidthPt, long szHeightPt)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x22f, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		szWidthPt, szHeightPt);
}

double CDUCCPLC::GetGaugeCurrentValue(long gaugeshape)
{
	double result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x230, DISPATCH_METHOD, VT_R8, (void*)&result, parms,
		gaugeshape);
	return result;
}

void CDUCCPLC::SetGaugeCurrentValue(long gaugeshape, double newvalue)
{
	static BYTE parms[] =
		VTS_I4 VTS_R8;
	InvokeHelper(0x231, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		gaugeshape, newvalue);
}

BOOL CDUCCPLC::SaveTemplateToFile(LPCTSTR strFile)
{
	BOOL result;
	static BYTE parms[] =
		VTS_BSTR;
	InvokeHelper(0x232, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms,
		strFile);
	return result;
}

BOOL CDUCCPLC::LoadTemplateFromFile(LPCTSTR strFile)
{
	BOOL result;
	static BYTE parms[] =
		VTS_BSTR;
	InvokeHelper(0x233, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms,
		strFile);
	return result;
}

double CDUCCPLC::GetZoomXScale()
{
	double result;
	InvokeHelper(0x234, DISPATCH_METHOD, VT_R8, (void*)&result, NULL);
	return result;
}

double CDUCCPLC::GetZoomYScale()
{
	double result;
	InvokeHelper(0x235, DISPATCH_METHOD, VT_R8, (void*)&result, NULL);
	return result;
}

double CDUCCPLC::GetUIScale()
{
	double result;
	InvokeHelper(0x236, DISPATCH_METHOD, VT_R8, (void*)&result, NULL);
	return result;
}

long CDUCCPLC::GetUIUnit()
{
	long result;
	InvokeHelper(0x237, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
	return result;
}

long CDUCCPLC::GetShapeID(long shape)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x238, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		shape);
	return result;
}

void CDUCCPLC::SetShapeID(long shape, long nId)
{
	static BYTE parms[] =
		VTS_I4 VTS_I4;
	InvokeHelper(0x239, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		shape, nId);
}

long CDUCCPLC::FindShapeByID(long nId)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x23a, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		nId);
	return result;
}

long CDUCCPLC::NewConnectTwoShapes(long node1, long node2, LPCTSTR node1portkey, LPCTSTR node2portkey)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_BSTR VTS_BSTR;
	InvokeHelper(0x23b, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		node1, node2, node1portkey, node2portkey);
	return result;
}

long CDUCCPLC::ConnectShapeWithPorts(long node1, long node2, LPCTSTR node1portkey, LPCTSTR node2portkey, short nLinkStyle)
{
	long result;
	static BYTE parms[] =
		VTS_I4 VTS_I4 VTS_BSTR VTS_BSTR VTS_I2;
	InvokeHelper(0x23c, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		node1, node2, node1portkey, node2portkey, nLinkStyle);
	return result;
}

CXDShape CDUCCPLC::Convert(long shape)
{
	LPDISPATCH pDispatch;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x23d, DISPATCH_METHOD, VT_DISPATCH, (void*)&pDispatch, parms,
		shape);
	return CXDShape(pDispatch);
}

void CDUCCPLC::LockUpdate(BOOL bLock)
{
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0x23e, DISPATCH_METHOD, VT_EMPTY, NULL, parms,
		bLock);
}

BOOL CDUCCPLC::IsLockUpdate()
{
	BOOL result;
	InvokeHelper(0x23f, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

CXDGroupShape CDUCCPLC::ConvertToGroup(long shape)
{
	LPDISPATCH pDispatch;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x240, DISPATCH_METHOD, VT_DISPATCH, (void*)&pDispatch, parms,
		shape);
	return CXDGroupShape(pDispatch);
}

CXDLinkShape CDUCCPLC::ConvertToLink(long shape)
{
	LPDISPATCH pDispatch;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x241, DISPATCH_METHOD, VT_DISPATCH, (void*)&pDispatch, parms,
		shape);
	return CXDLinkShape(pDispatch);
}

CXDPortsShape CDUCCPLC::ConvertToPortsShape(long shape)
{
	LPDISPATCH pDispatch;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x242, DISPATCH_METHOD, VT_DISPATCH, (void*)&pDispatch, parms,
		shape);
	return CXDPortsShape(pDispatch);
}

CXDPortShape CDUCCPLC::ConvertToPortShape(long shape)
{
	LPDISPATCH pDispatch;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x243, DISPATCH_METHOD, VT_DISPATCH, (void*)&pDispatch, parms,
		shape);
	return CXDPortShape(pDispatch);
}

CXDEFormShape CDUCCPLC::ConvertToEFormShape(long shape)
{
	LPDISPATCH pDispatch;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x244, DISPATCH_METHOD, VT_DISPATCH, (void*)&pDispatch, parms,
		shape);
	return CXDEFormShape(pDispatch);
}

void CDUCCPLC::UpdateFullWindows()
{
	InvokeHelper(0x245, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::HideAllToolBars()
{
	InvokeHelper(0x246, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::HideCanvasBorder()
{
	InvokeHelper(0x247, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}

void CDUCCPLC::HideAllScrollBars()
{
	InvokeHelper(0x248, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
}
